<?php

require_once(dirname(__FILE__).'/../../../core/admin/prepend.php');

class archive {
    
	
	public $saved_dirs = array(
		'data/',
	);
	
	
	
    public function __construct($save_dir='../../sauvegarde/',$days='14',$saved_dirs)
    {
		if($saved_dirs) {
			$this->saved_dirs = explode(",", $saved_dirs);
		}
        $this->save_dir = (substr($save_dir, -1) != '/') ? $save_dir.'/' : $save_dir;
		
		if (is_numeric($days)) {
			$this->days = $days;
		}
		
		else { return false; }
		return true;
    }
	
	
	public function zip() {
		$zip_name = 'archive.'.date('ymd').'.zip';
		$zip = new Zip($zip_name,$this->save_dir);
		foreach($this->saved_dirs as $dir) {
			$zip->add('../../'.$dir);
			// On supprime les références aux dossiers précédents ..
			$zip->renameName('../../'.$dir,$dir);
		}
		$zip->close();
		$this->lastbackup = date('ymd');
	}

	
	public function check() {
		// récuperation de la date de la dernière archive
		$date = array();
		$dir = @opendir($this->save_dir);
		if($dir) {
			// parcours des archives
			while ($file = readdir($dir)) {
				if ($file != "." && $file != ".." && !is_dir($file) && $file != ".htaccess") {
					$index = explode('.',$file);
					$date[] = $index[1];
				}
			}
			closedir($dir);
			// s'il n'existe pas de fichier, retourner vrai
			if (!count($date)) {
				$this->lastbackup = 1;
				return true;
			}
			else {
				$lastbackup = max($date);
				$this->lastbackup = $lastbackup;
				$day = substr($lastbackup, -2, 2); // yymmdd -> dd
				$month = substr($lastbackup, -4, 2); // yymmdd -> mm
				$year = substr($lastbackup, -6, 2); // yymmdd -> yy
				$days = (strtotime(date("Y-m-d")) - strtotime($year.'-'.$month.'-'.$day)) / (60 * 60 * 24);
				// Si l'écart entre aujourd'hui et la dernière sauvegarde excède le nombre de jours paramétré, retourner vrai
				if($days >= $this->days) {
					return true;
				}
				// sinon retourner faux
				else { return false; }
			}
		}
		else {
			// Création du dossier
			if(mkdir($this->save_dir)) {
				// Création du htaccess
				$this->htaccess($this->save_dir);
				// Vérification du success et recherche de sauvegarde
				$this->check();
			}
			else { return false; }
		}
	}
	
	
	
	public function sendmail($email,$email_sender='nobody@save.com',$sender='Sauvegarde',$titre='Sauvegarde site internet',$message='Vous trouverez ci-joint la dernière sauvegarde du contenu de votre site internet.') {
		if($this->lastbackup) {
			$mail = new PHPMailerLite(); // defaults to using php "Sendmail" (or Qmail, depending on availability)
			$mail->IsMail(); // telling the class to use native PHP mail()
			try {
				  $mail->SetFrom($email_sender, $sender);
				  $mail->CharSet = 'utf-8';
				  $mail->AddAddress($email, $email);
				  $mail->Subject = $titre.' '. $this->lastbackup;
				  $mail->Body = $message; // Body text/plain

				  $mail->AddAttachment($this->save_dir.'archive.'.$this->lastbackup.'.zip');      // attachment
				  return $mail->Send();
			} 
			catch (phpmailerException $e) { return false; } 
			catch (Exception $e) { return false; }
		}
	}
	
	
	public function displaylist() {
		global $plxShow;
		$dirname = $this->save_dir;
		$dir = @opendir($dirname);
		$i = 0;
		if ($dir) {
			echo '<table>';
			while($file = readdir($dir)) {
				if($file != '.' && $file != '..' && !is_dir($dirname.$file) && substr($file, 0, 1) != '.')
				{
					echo '<tr><td class="name"><a href="'.$dirname.$file.'">'.$file.'</a></td><td>'.$this->format_bytes(filesize($dirname.$file)).'</td><td><a href="parametres_plugin.php?p=BackUpData&d='.plxEncrypt::encryptId($file).'" onclick="return confirm(\'Êtes-vous sûr de vouloir supprimer l’'.$file.' ?\')">X</a></td></tr>';
					$i++;
				}
			}
			if ($i==0) {
					echo '<tr><td><em>Aucune archive disponible.</em></td></tr>';
			}
			echo '</table>';
			closedir($dir);
		}
	}
	
	

	private function format_bytes($size) {
		$units = array(' o', ' Ko', ' Mo', ' Go', ' To');
		for ($i = 0; $size >= 1024 && $i < 4; $i++) $size /= 1024;
		return round($size, 2).$units[$i];
	}
	
	

	private function htaccess($path) {
		$htaccess = "options -indexes";
		file_put_contents($path.'.htaccess',$htaccess);
	}
}
?>