<?php if(!defined('PLX_ROOT')) exit; ?>
<?php
require_once('class/class.zip.php');
require_once('class/class.phpmailer-lite.php');
require_once('class/class.archive.php');

// valeurs par défaut
if(!$plxPlugin->getParam('savedir')) { $plxPlugin->setParam('savedir', '../../backup/', 'string'); }
if(!$plxPlugin->getParam('days')) { $plxPlugin->setParam('days', '7', 'numeric'); }


$archive = new archive($plxPlugin->getParam('savedir'),$plxPlugin->getParam('days'),$plxPlugin->getParam('saved_dirs'));
$archive->check();
if(!empty($_POST)) {
	$plxPlugin->setParam('savedir', $_POST['savedir'], 'string');
	$plxPlugin->setParam('days', $_POST['days'], 'numeric');
	$plxPlugin->setParam('email', $_POST['email'], 'string');
	$plxPlugin->setParam('senderemail', $_POST['senderemail'], 'string');
	$plxPlugin->setParam('sendername', $_POST['sendername'], 'string');

	$dirs = implode(',',$_POST['data']);
	$plxPlugin->setParam('saved_dirs', $dirs, 'string');
	$plxPlugin->saveParams();
	header('Location: parametres_plugin.php?p=BackUpData');
	exit;
}

if($_GET['action'] == 'zip') {
		$archive->zip();
		plxMsg::Info('Archive a été crée avec succès');
}

if($_GET['action'] == 'mail') {
	if($archive->sendmail($plxPlugin->getParam('email'),$plxPlugin->getParam('senderemail'),$plxPlugin->getParam('sendername'),$plxPlugin->getLang('L_TITLE'),$plxPlugin->getLang('L_CONTENT'))) { 
		plxMsg::Info('Email a été envoyé avec succès'); 
	}
}

if(isset($_GET['f']) && file_exists($plxPlugin->getParam('savedir').plxEncrypt::decryptId($_GET['f'])))
{
	ob_start();
	header('Expires: 0');
	header('Cache-Control: private');
	header('Pragma: cache');
	header('Content-Disposition: attachment; filename="'.plxEncrypt::decryptId($_GET['f']).'"');
	header('Content-type: application/x-zip-compressed');
	ob_end_clean();
	readfile($plxPlugin->getParam('savedir').plxEncrypt::decryptId($_GET['f']));
}

if(isset($_GET['d']) && file_exists($plxPlugin->getParam('savedir').plxEncrypt::decryptId($_GET['d'])))
{
	unlink($plxPlugin->getParam('savedir').plxEncrypt::decryptId($_GET['d']));
	plxMsg::Info('Le fichier '.plxEncrypt::decryptId($_GET['d']).' a bien été supprimé'); 
}
?>

<style>
	input, textarea {border-radius: 5px;width: 40%}
	input.numeric{width: 100px}
	textarea {min-height: 50px}
	label{font-style: italic}
	td>input{width: 100%}
	a.bt{padding:10px 25px;border:2px solid #616161;border-radius:4px;color:#616161;font-size:13px;text-decoration: none;}
</style>

<!-- navigation sur la page configuration du plugin -->
<h2>Configuration et sauvegarde de votre dossier data</h2>


	<nav id="tabby-1" class="tabby-tabs" data-for="example-tab-content">
		<ul>
			<li><a data-target="tab1" class="active" href="#">Archives</a></li>
			<li><a data-target="tab2" href="#">Créer ou envoyer Archive</a></li>
			<li><a data-target="tab3" href="#">Configuration</a></li>
		</ul>
	</nav> 

<div class="tabby-content" id="example-tab-content">



<div data-tab="tab1">	

<h3>Archives disponibles sur votre serveur</h3>

	<p>
		<?php $archive->displaylist() ?>
	</p>

	<h3>
		Envoyer par mail la dernière archive
	</h3>

	<p>
		<a class="bt" href="parametres_plugin.php?p=BackUpData&action=mail"title="<?php $plxPlugin->lang('L_MAIL_CONFIG') ?>">Envoyer l'archive par mail ?</a>
	</p>
		
</div>

<div data-tab="tab2">

	

	<h3>Sauvegarde</h3>

	<p>
		Réaliser la sauvegarde de votre dossier data à la date du jour
	</p>

		<p>
			<a class="bt" href="parametres_plugin.php?p=BackUpData&action=zip" title="<?php $plxPlugin->lang('L_ARCHIVE_CONFIG') ?>">Créer l'archive ?</a>
		</p>

</div>

<div data-tab="tab3">

	<h3>Options de configuration</h3>

	<form action="parametres_plugin.php?p=BackUpData" method="post" class="formulaire">
		<fieldset>

			<p>
				<label><?php $plxPlugin->lang('L_SAVEDIR_CONFIG') ?></label> 
				<input type="text" name="savedir" value="<?php echo plxUtils::strCheck($plxPlugin->getParam('savedir')) ?>" />
			</p>
			
			<p>
				<label><?php $plxPlugin->lang('L_DAY_CONFIG') ?></label> 
				<input type="text" name="days" value="<?php echo plxUtils::strCheck($plxPlugin->getParam('days')) ?>" />
			</p>
			
			<p>
				<label><?php $plxPlugin->lang('L_EMAIL_CONFIG') ?></label> 
				<input type="text" name="email" value="<?php echo plxUtils::strCheck($plxPlugin->getParam('email')) ?>" />
			</p>
			
			<p>
				<label><?php $plxPlugin->lang('L_EMAILSENDER_CONFIG') ?></label> 
				<input type="text" name="senderemail" value="<?php echo plxUtils::strCheck($plxPlugin->getParam('senderemail')) ?>" />
			</p>
			
			<p>
				<label><?php $plxPlugin->lang('L_SENDERNAME_CONFIG') ?></label> 
				<input type="text" name="sendername" value="<?php echo plxUtils::strCheck($plxPlugin->getParam('sendername')) ?>" />
			</p>
			

			<p class="in-action-bar">
				<?php echo plxToken::getTokenPostMethod() ?>
				<input type="submit" name="submit" value="Valider" />
			</p>


		</fieldset>
	</form>

</div>

<script src="http://cdnjs.cloudflare.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="<?php echo PLX_PLUGINS ?>BackUpData/app/jquery.tabby.js"></script>
<script>
    $(document).ready(function(){
        $('#tabby-1').tabby();
    });
</script>	
